import type { CallbackStore } from '@looker/chatty';
import type { LookerAuthConfig, LookerEmbedEventMap, LookerEmbedFilterParams, IEmbedBuilder, IEmbedClient, PageType, UrlParams } from './types';
import type { LookerEmbedExSDK } from './LookerEmbedExSDK';
export declare class EmbedBuilderEx implements IEmbedBuilder {
    private _sdk;
    private _type;
    private _endpoint;
    private _handlers;
    private _appendTo;
    private _sandboxAttrs;
    private _allowAttrs;
    private _classNames;
    private _frameBorder;
    private _id?;
    private _params;
    private _url?;
    private _sandboxedHost?;
    private _scrollMonitor?;
    private _dynamicIFrameHeight?;
    private _dialogScroll?;
    private _allowLoginScreen?;
    constructor(_sdk: LookerEmbedExSDK, _type: PageType, _endpoint: string);
    withFrameBorder(attr: string): IEmbedBuilder;
    withId(id: number | string): IEmbedBuilder;
    withParams(params: UrlParams): IEmbedBuilder;
    withFilters(filters: LookerEmbedFilterParams, escape?: boolean | undefined): IEmbedBuilder;
    withSandboxAttr(...attr: string[]): IEmbedBuilder;
    withAllowAttr(...attr: string[]): IEmbedBuilder;
    withClassName(...className: string[]): IEmbedBuilder;
    withTheme(theme: string): IEmbedBuilder;
    withScrollMonitor(monitor?: boolean | undefined): IEmbedBuilder;
    withDynamicIFrameHeight(dynamicIFrameHeight?: boolean | undefined): IEmbedBuilder;
    withDialogScroll(dialogScroll?: boolean | undefined): IEmbedBuilder;
    withApiHost(apiHost: string): IEmbedBuilder;
    withAuthUrl(authUrl: string): IEmbedBuilder;
    withAuth(auth: LookerAuthConfig): IEmbedBuilder;
    withUrl(url: string): IEmbedBuilder;
    withAllowLoginScreen(): IEmbedBuilder;
    /**
     * @deprecated
     */
    withNext(_?: string): IEmbedBuilder;
    set sandboxedHost(sandboxedHost: boolean);
    get sandboxedHost(): boolean;
    get el(): HTMLElement;
    get frameBorder(): string;
    get endpoint(): string;
    get type(): PageType;
    get apiHost(): string;
    get isCookielessEmbed(): boolean;
    get acquireSession(): string | import("./types").CookielessRequestInit | import("./types").CookielessCallback;
    get generateTokens(): string | import("./types").CookielessRequestInit | import("./types").GenerateTokensCallback;
    get auth(): LookerAuthConfig;
    get embedUrl(): string;
    get handlers(): CallbackStore;
    get sandboxAttrs(): string[];
    get allowAttrs(): string[];
    get classNames(): string[];
    get id(): string | number | undefined;
    get scrollMonitor(): boolean | undefined;
    get dynamicIFrameHeight(): boolean | undefined;
    get dialogScroll(): boolean | undefined;
    get allowLoginScreen(): boolean | undefined;
    appendTo(el: HTMLElement | string): IEmbedBuilder;
    on<K extends keyof LookerEmbedEventMap>(name: K, handler: LookerEmbedEventMap[K]): IEmbedBuilder;
    build(): IEmbedClient;
}
