import type { ChattyHostConnection } from '@looker/chatty';
import type { ILookerConnection, ILookerEmbedDashboard, ILookerEmbedExplore, ILookerEmbedExtension, ILookerEmbedLook, ILookerEmbedQueryVisualization, ILookerEmbedReport, LoadIdParams, LoadUrlParams, PageType, LookerDashboardOptions, LookerEmbedFilterParams, IConnectOptions } from './types';
import type { EmbedClientEx } from './EmbedClientEx';
export declare class EmbedConnection implements ILookerConnection {
    private _host;
    private _embedClient;
    _pageType: PageType;
    _isEditing: boolean;
    _currentPathname: string;
    constructor(_host: ChattyHostConnection, _embedClient: EmbedClientEx);
    send(message: string, params?: any): void;
    sendAndReceive(message: string, params?: any): Promise<any>;
    getLookerVersion(): number;
    loadUrl({ url, pushHistory, options, }: LoadUrlParams): Promise<any>;
    loadId({ type, id, pushHistory, options, }: LoadIdParams): Promise<void>;
    loadDashboard(id: string, pushHistory?: boolean, options?: IConnectOptions): Promise<any>;
    loadExplore(id: string, pushHistory?: boolean, options?: IConnectOptions): Promise<void>;
    loadMergeQuery(id: string, pushHistory?: boolean, options?: IConnectOptions): Promise<any>;
    loadQuery(model: string, view: string, qid: string, pushHistory?: boolean, options?: IConnectOptions): Promise<any>;
    loadLook(id: string, pushHistory?: boolean, options?: IConnectOptions): Promise<void>;
    loadExtension(id: string, pushHistory?: boolean, options?: IConnectOptions): Promise<void>;
    loadQueryVisualization(id: string, pushHistory?: boolean, options?: IConnectOptions): Promise<void>;
    loadReport(id: string, pushHistory?: boolean, options?: IConnectOptions): Promise<void>;
    preload(pushHistory?: boolean, options?: IConnectOptions): Promise<any>;
    asDashboardConnection(): ILookerEmbedDashboard;
    asExploreConnection(): ILookerEmbedExplore;
    asExtensionConnection(): ILookerEmbedExtension;
    asLookConnection(): ILookerEmbedLook;
    asQueryVisualizationConnection(): ILookerEmbedQueryVisualization;
    asReportConnection(): ILookerEmbedReport;
    getPageType(): PageType;
    isEditing(): boolean;
    hasSessionExpired(): boolean;
    /**
     * @deprecated use asXXXConnection().run() instead
     */
    run(): void;
    /**
     * @deprecated use asDashboardConnection().stop() instead
     */
    stop(): void;
    /**
     * @deprecated use asDashboardConnection().edit() instead
     */
    edit(): void;
    /**
     * @deprecated use asXXXConnection().updateFilters(params) instead
     */
    updateFilters(params: LookerEmbedFilterParams): void;
    /**
     * @deprecated use asDashboardConnection().setOptions(options) instead
     */
    setOptions(options: LookerDashboardOptions): void;
    /**
     * @deprecated use asDashboardConnection().openScheduleDialog() instead
     */
    openScheduleDialog(): Promise<void>;
}
