import type { LookerEmbedFilterParams, ILookerEmbedExplore } from './types';
import type { EmbedConnection } from './EmbedConnection';
/**
 * Client that communicates with an embedded Looker explore. Messages are documented
 * [here](https://docs.looker.com/r/sdk/events)
 */
export declare class ExploreConnection implements ILookerEmbedExplore {
    private _connection;
    constructor(_connection: EmbedConnection);
    /**
     * Convenience method for sending a run message to the embedded Explore.
     */
    run(): void;
    /**
     * Convenience method for updating the filters of the embedded Explore.
     *
     * @param filters A set of filter parameters to update
     */
    updateFilters(params: LookerEmbedFilterParams): void;
}
