"use strict";
/*

 MIT License

 Copyright (c) 2019 Looker Data Sciences, Inc.

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all
 copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 SOFTWARE.

 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LookerEmbedSDK = void 0;
var LookerEmbedExSDK_1 = require("./LookerEmbedExSDK");
__exportStar(require("./types"), exports);
__exportStar(require("./LookerEmbedExSDK"), exports);
__exportStar(require("./types"), exports);
/**
 * @deprecated Use <code>getEmbedSDK()</code> instead.
 */
var LookerEmbedSDK = /** @class */ (function () {
    function LookerEmbedSDK() {
    }
    /**
     * Initialize the Embed SDK.
     *
     * @param apiHost The address or base URL of the Looker host (example.looker.com:9999, https://example.looker.com:9999)
     *                This is required for verification of messages sent from the embedded content.
     * @param authUrl A server endpoint that will sign SSO embed URLs
     *
     * @deprecated Use <code>getEmbedSDK().init(...)</code> instead.
     */
    LookerEmbedSDK.init = function (apiHost, auth) {
        (0, LookerEmbedExSDK_1.getEmbedSDK)().init(apiHost, auth);
    };
    /**
     * Initialize the Embed SDK to use a cookieless session.
     *
     * @param apiHost The address or base URL of the host (example.looker.com:9999, https://example.looker.com:9999)
     * @param acquireSession is either a string containing a server endpoint that will acquire the embed session OR
     * a RequestInfo object for a fetch call to the server endpoint that will acquire the embed session OR
     * a callback that will invoke the server endpoint that will acquire the embed session.
     * The server endpoint must ultimately call the Looker endpoint `acquire_embed_cookieless_session`.
     * @param generateTokens is either a string containing a server endpoint that will generate new tokens OR
     * a RequestInfo object for a fetch call to the server endpoint that will generate new tokens OR
     * a callback that will invoke the server endpoint that will generate new tokens.
     * The server endpoint should ultimately call the Looker endpoint `generate_tokens_for_cookieless_session`.
     *
     * Looker 22.20+
     *
     * @deprecated Use <code>getEmbedSDK().initCookieless(...)</code> instead.
     */
    LookerEmbedSDK.initCookieless = function (apiHost, acquireSession, generateTokens) {
        (0, LookerEmbedExSDK_1.getEmbedSDK)().initCookieless(apiHost, acquireSession, generateTokens);
    };
    /**
     * Create an EmbedBuilder for an embedded Looker dashboard.
     *
     * @param url A signed SSO embed URL or embed URL for an already authenticated Looker user
     *
     * @deprecated Use <code>getEmbedSDK().createDashboardWithUrl(...)</code> instead.
     */
    LookerEmbedSDK.createDashboardWithUrl = function (url) {
        return (0, LookerEmbedExSDK_1.getEmbedSDK)().createDashboardWithUrl(url);
    };
    /**
     * Create an EmbedBuilder for an embedded Looker dashboard.
     *
     * @param id The numeric ID of a Looker User Defined Dashboard, or LookML Dashboard ID
     *
     * @deprecated Use <code>getEmbedSDK().createDashboardWithId(...)</code> instead.
     */
    LookerEmbedSDK.createDashboardWithId = function (id) {
        return (0, LookerEmbedExSDK_1.getEmbedSDK)().createDashboardWithId(id);
    };
    /**
     * Create an EmbedBuilder for an embedded Looker Explore.
     *
     * @param url A signed SSO embed URL or embed URL for an already authenticated Looker user
     *
     * @deprecated Use <code>getEmbedSDK().createExploreWithUrl(...)</code> instead.
     */
    LookerEmbedSDK.createExploreWithUrl = function (url) {
        return (0, LookerEmbedExSDK_1.getEmbedSDK)().createExploreWithUrl(url);
    };
    /**
     * Create an EmbedBuilder for an embedded Looker Explore.
     *
     * @param id The ID of a Looker explore
     *
     * @deprecated Use <code>getEmbedSDK().createExploreWithId(...)</code> instead.
     */
    LookerEmbedSDK.createExploreWithId = function (id) {
        return (0, LookerEmbedExSDK_1.getEmbedSDK)().createExploreWithId(id);
    };
    /**
     * Create an EmbedBuilder for an embedded Looker Look.
     *
     * @param url A signed SSO embed URL or embed URL for an already authenticated Looker user
     *
     * @deprecated Use <code>getEmbedSDK().createLookWithUrl(...)</code> instead.
     */
    LookerEmbedSDK.createLookWithUrl = function (url) {
        return (0, LookerEmbedExSDK_1.getEmbedSDK)().createLookWithUrl(url);
    };
    /**
     * Create an EmbedBuilder for an embedded Looker dashboard.
     *
     * @param id The ID of a Looker Look
     *
     * @deprecated Use <code>getEmbedSDK().createLookWithId(...)</code> instead.
     */
    LookerEmbedSDK.createLookWithId = function (id) {
        return (0, LookerEmbedExSDK_1.getEmbedSDK)().createLookWithId(id);
    };
    /**
     * Create an EmbedBuilder for an embedded Looker extension.
     *
     * @param url A signed SSO embed URL or embed URL for an already authenticated Looker user
     *
     * @deprecated Use <code>getEmbedSDK().createExtensionWithUrl(...)</code> instead.
     */
    LookerEmbedSDK.createExtensionWithUrl = function (url) {
        return (0, LookerEmbedExSDK_1.getEmbedSDK)().createExtensionWithUrl(url);
    };
    /**
     * Create an EmbedBuilder for an embedded Looker extension. Requires Looker 7.12
     *
     * @param id The ID of a Looker Look
     *
     * @deprecated Use <code>getEmbedSDK().createExtensionWithId(...)</code> instead.
     */
    LookerEmbedSDK.createExtensionWithId = function (id) {
        return (0, LookerEmbedExSDK_1.getEmbedSDK)().createExtensionWithId(id);
    };
    return LookerEmbedSDK;
}());
exports.LookerEmbedSDK = LookerEmbedSDK;
//# sourceMappingURL=index.js.map